searchNodes=[{"doc":"","ref":"Gnat.html","title":"Gnat","type":"module"},{"doc":"get the number of active subscriptions","ref":"Gnat.html#active_subscriptions/1","title":"Gnat.active_subscriptions/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Gnat.html#child_spec/1","title":"Gnat.child_spec/1","type":"function"},{"doc":"Ping the NATS serverThis correlates to the PING command in the NATS protocol. If the NATS server responds with a PONG message this function will return :ok{:ok, gnat} = Gnat.start_link() :ok = Gnat.ping(gnat)","ref":"Gnat.html#ping/1","title":"Gnat.ping/1","type":"function"},{"doc":"Publish a message{:ok, gnat} = Gnat.start_link() :ok = Gnat.pub(gnat, &quot;characters&quot;, &quot;Ron Swanson&quot;)If you want to provide a reply address to receive a response you can pass it as an option. See request-response pattern.{:ok, gnat} = Gnat.start_link() :ok = Gnat.pub(gnat, &quot;characters&quot;, &quot;Star Lord&quot;, reply_to: &quot;me&quot;)","ref":"Gnat.html#pub/4","title":"Gnat.pub/4","type":"function"},{"doc":"Send a request and listen for a response synchronouslyFollowing the nats request-response pattern this function generates a one-time topic to receive replies and then sends a message to the provided topic.Supported options:receive_timeout: an integer number of milliseconds to wait for a response. Defaults to 60_000{:ok, gnat} = Gnat.start_link() case Gnat.request(gnat, &quot;i_can_haz_cheezburger&quot;, &quot;plZZZZ?!?!?&quot;) do {:ok, %{body: delicious_cheezburger}} -&gt; :yum {:error, :timeout} -&gt; :sad_cat end","ref":"Gnat.html#request/4","title":"Gnat.request/4","type":"function"},{"doc":"Starts a connection to a nats broker{:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222}) # if the server requires TLS you can start a connection with: {:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222, tls: true}) # if the server requires TLS and a client certificate you can start a connection with: {:ok, gnat} = Gnat.start_link(%{tls: true, ssl_opts: [certfile: &quot;client-cert.pem&quot;, keyfile: &quot;client-key.pem&quot;]})You can also pass arbitrary SSL or TCP options in the tcp_opts and ssl_opts keys. If you pass custom TCP options please include :binary. Gnat uses binary matching to parse messages.The final opts argument will be passed to the GenServer.start_link call so you can pass things like [name: :gnat_connection].","ref":"Gnat.html#start_link/2","title":"Gnat.start_link/2","type":"function"},{"doc":"Gracefull shuts down a connection{:ok, gnat} = Gnat.start_link() :ok = Gnat.stop(gnat)","ref":"Gnat.html#stop/1","title":"Gnat.stop/1","type":"function"},{"doc":"Subscribe to a topicSupported options:queue_group: a string that identifies which queue group you want to joinBy default each subscriber will receive a copy of every message on the topic. When a queue_group is supplied messages will be spread among the subscribers in the same group. (see nats queueing)The subscribed process will begin receiving messages with a structure of sent_message/0{:ok, gnat} = Gnat.start_link() {:ok, subscription} = Gnat.sub(gnat, self(), &quot;topic&quot;) receive do {:msg, %{topic: &quot;topic&quot;, body: body}} -&gt; IO.puts &quot;Received: \#{body}&quot; end","ref":"Gnat.html#sub/4","title":"Gnat.sub/4","type":"function"},{"doc":"Unsubscribe from a topicSupported options:max_messages: number of messages to be received before automatically unsubscribedThis correlates to the UNSUB command in the nats protocol. By default the unsubscribe is affected immediately, but an optional max_messages value can be provided which will allow max_messages to be received before affecting the unsubscribe. This is especially useful for request response patterns.{:ok, gnat} = Gnat.start_link() {:ok, subscription} = Gnat.sub(gnat, self(), &quot;my_inbox&quot;) :ok = Gnat.unsub(gnat, subscription) # OR :ok = Gnat.unsub(gnat, subscription, max_messages: 2)","ref":"Gnat.html#unsub/3","title":"Gnat.unsub/3","type":"function"},{"doc":"","ref":"Gnat.html#t:message/0","title":"Gnat.message/0","type":"type"},{"doc":"","ref":"Gnat.html#t:sent_message/0","title":"Gnat.sent_message/0","type":"type"},{"doc":"","ref":"Gnat.html#t:t/0","title":"Gnat.t/0","type":"type"},{"doc":"","ref":"Gnat.Command.html","title":"Gnat.Command","type":"module"},{"doc":"","ref":"Gnat.Command.html#build/3","title":"Gnat.Command.build/3","type":"function"},{"doc":"","ref":"Gnat.Command.html#build/4","title":"Gnat.Command.build/4","type":"function"},{"doc":"A process that can supervise a named connection for youIf you would like to supervise a Gnat connection and have it automatically re-connect in case of failure you can use this module in your supervision tree. It takes a map with the following data:gnat_supervisor_settings = %{ name: :gnat, # (required) the registered named you want to give the Gnat connection backoff_period: 4_000, # number of milliseconds to wait between consecutive reconnect attempts (default: 2_000) connection_settings: [ %{host: &#39;10.0.0.100&#39;, port: 4222}, %{host: &#39;10.0.0.101&#39;, port: 4222}, ] }The connection settings can specify all of the same values that you pass to Gnat.start_link/1. Each time a connection is attempted we will use one of the provided connection settings to open the connection. This is a simplistic way of load balancing your connections across a cluster of nats nodes and allowing failover to other nodes in the cluster if one goes down.To use this in your supervision tree add an entry like this:import Supervisor.Spec worker(Gnat.ConnectionSupervisor, [gnat_supervisor_settings, [name: :my_connection_supervisor]])The second argument is used as GenServer options so you can give the supervisor a registered name as well if you like. Now in the rest of your code you can call things like::ok = Gnat.pub(:gnat, &quot;subject&quot;, &quot;message&quot;)And it will use your supervised connection. If the connection is down when you call that function (or dies during that function) it will raise an error.","ref":"Gnat.ConnectionSupervisor.html","title":"Gnat.ConnectionSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Gnat.ConnectionSupervisor.html#child_spec/1","title":"Gnat.ConnectionSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Gnat.ConnectionSupervisor.html#start_link/2","title":"Gnat.ConnectionSupervisor.start_link/2","type":"function"},{"doc":"A process that can supervise consumers for youIf you want to subscribe to a few topics and have that subscription last across restarts for you, then this worker can be of help. It also spawns a supervised Task for each message it receives. This way errors in message processing don't crash the consumers, but you will still get SASL reports that you can send to services like honeybadger.To use this just add an entry to your supervision tree like this:consumer_supervisor_settings = %{ connection_name: :name_of_supervised_connection, module: MyApp.Server, # a module that implements the Gnat.Server behaviour subscription_topics: [ %{topic: &quot;rpc.MyApp.search&quot;, queue_group: &quot;rpc.MyApp.search&quot;}, %{topic: &quot;rpc.MyApp.create&quot;, queue_group: &quot;rpc.MyApp.create&quot;}, ], } worker(Gnat.ConsumerSupervisor, [consumer_supervisor_settings, [name: :rpc_consumer]], shutdown: 30_000)The second argument is a keyword list that gets used as the GenServer options so you can pass a name that you want to register for the consumer process if you like. The :consuming_function specifies which module and function to call when messages arrive. The function will be called with a single argument which is a Gnat.message/0 just like you get when you call Gnat.sub/4 directly.You can have a single consumer that subscribes to multiple topics or multiple consumers that subscribe to different topics and call different consuming functions. It is recommended that your ConsumerSupervisors are present later in your supervision tree than your ConnectionSupervisor. That way during a shutdown the ConsumerSupervisor can attempt a graceful shutdown of the consumer before shutting down the connection.It's also possible to pass a %{consuming_function: {YourModule, :your_function}} rather than a :module in your settings. In that case no error handling or replying is taking care of for you, it will be up to your function to take whatever action you want with each message.","ref":"Gnat.ConsumerSupervisor.html","title":"Gnat.ConsumerSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Gnat.ConsumerSupervisor.html#child_spec/1","title":"Gnat.ConsumerSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Gnat.ConsumerSupervisor.html#start_link/2","title":"Gnat.ConsumerSupervisor.start_link/2","type":"function"},{"doc":"This module provides a single function which handles all of the variations of establishing a connection to a gnatsd server and just returns {:ok, socket} or {:error, reason}","ref":"Gnat.Handshake.html","title":"Gnat.Handshake","type":"module"},{"doc":"","ref":"Gnat.Handshake.html#connect/1","title":"Gnat.Handshake.connect/1","type":"function"},{"doc":"","ref":"Gnat.Parsec.html","title":"Gnat.Parsec","type":"module"},{"doc":"","ref":"Gnat.Parsec.html#finish_msg/6","title":"Gnat.Parsec.finish_msg/6","type":"function"},{"doc":"","ref":"Gnat.Parsec.html#new/0","title":"Gnat.Parsec.new/0","type":"function"},{"doc":"","ref":"Gnat.Parsec.html#parse/2","title":"Gnat.Parsec.parse/2","type":"function"},{"doc":"","ref":"Gnat.Parsec.html#parse_command/1","title":"Gnat.Parsec.parse_command/1","type":"function"},{"doc":"","ref":"Gnat.Parsec.html#parse_commands/2","title":"Gnat.Parsec.parse_commands/2","type":"function"},{"doc":"A behavior for acting as a server for nats messages.You can use this behavior in your own module and then use the Gnat.ConsumerSupervisor to listen for and respond to nats messages.Exampledefmodule MyApp.RpcServer do use Gnat.Server def request(%{body: _body}) do {:reply, &quot;hi&quot;} end # defining an error handler is optional, the default one will just call Logger.error for you def error(%{gnat: gnat, reply_to: reply_to}, _error) do Gnat.pub(gnat, reply_to, &quot;Something went wrong and I can&#39;t handle your request&quot;) end end","ref":"Gnat.Server.html","title":"Gnat.Server","type":"behaviour"},{"doc":"Called when an error occured during the request/1If your request/1 function returned {:error, term}, then the term you returned will be passed as the second argument. If an exception was raised during your request/1 function, then the exception will be passed as the second argument. If your request/1 function returned something other than the supported return types, then its return value will be passed as the second argument.","ref":"Gnat.Server.html#c:error/2","title":"Gnat.Server.error/2","type":"callback"},{"doc":"Called when a message is received from the broker","ref":"Gnat.Server.html#c:request/1","title":"Gnat.Server.request/1","type":"callback"},{"doc":"GnatA nats.io client for Elixir. The goals of the project are resiliency, performance, and ease of use.Hex documentation available here: https://hex.pm/packages/gnat","ref":"readme.html","title":"Gnat","type":"extras"},{"doc":"{:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222}) # Or if the server requires TLS you can start a connection with: # {:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222, tls: true}) {:ok, subscription} = Gnat.sub(gnat, self(), &quot;pawnee.*&quot;) :ok = Gnat.pub(gnat, &quot;pawnee.news&quot;, &quot;Leslie Knope recalled from city council (Jammed)&quot;) receive do {:msg, %{body: body, topic: &quot;pawnee.news&quot;, reply_to: nil}} -&gt; IO.puts(body) end","ref":"readme.html#usage","title":"Gnat - Usage","type":"extras"},{"doc":"# with user and password {:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222, username: &quot;joe&quot;, password: &quot;123&quot;, auth_required: true}) # with token {:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222, token: &quot;secret&quot;, auth_required: true}) # with nkeys {:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222, nkey_seed: &quot;SUAM...&quot;, auth_required: true}) # with user credentials {:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222, nkey_seed: &quot;SUAM...&quot;, jwt: &quot;eyJ0eX...&quot;, auth_required: true}) # connect to NGS {:ok, gnat} = Gnat.start_link(%{host: &quot;connect.ngs.global&quot;, tls: true, jwt: &quot;ey...&quot;, nkey_seed: &quot;SUAM...&quot;})","ref":"readme.html#authentication","title":"Gnat - Authentication","type":"extras"},{"doc":"Nats Server is often configured to accept or require TLS connections. In order to connect to these clusters you'll want to pass some extra TLS settings to your Gnat connection.# using a basic TLS connection {:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222, tls: true}) # Passing a Client Certificate for verification {:ok, gnat} = Gnat.start_link(%{tls: true, ssl_opts: [certfile: &quot;client-cert.pem&quot;, keyfile: &quot;client-key.pem&quot;]})","ref":"readme.html#tls-connections","title":"Gnat - TLS Connections","type":"extras"},{"doc":"If you would like to stay connected to a cluster of nats servers, you should consider using Gnat.ConnectionSupervisor . This can be added to your supervision tree in your project and will handle automatically re-connecting to the cluster.For long-lived subscriptions consider using Gnat.ConsumerSupervisor . This can also be added to your supervision tree and use a supervised connection to re-establish a subscription. It also handles details like handling each message in a supervised process so you isolate failures and get OTP logs when an unexpected error occurs.","ref":"readme.html#resiliency","title":"Gnat - Resiliency","type":"extras"},{"doc":"Gnat uses telemetry to make instrumentation data available to clients. If you want to record metrics around the number of messages or latency of message publishes, subscribes, requests, etc you can do the following in your project:iex(1)&gt; metrics_function = fn(event_name, measurements, event_meta, config) -&gt; IO.inspect([event_name, measurements, event_meta, config]) :ok end #Function&lt;4.128620087/4 in :erl_eval.expr/5&gt; iex(2)&gt; names = [[:gnat, :pub], [:gnat, :sub], [:gnat, :message_received], [:gnat, :request], [:gnat, :unsub]] [ [:gnat, :pub], [:gnat, :sub], [:gnat, :message_received], [:gnat, :request], [:gnat, :unsub] ] iex(3)&gt; :telemetry.attach_many(&quot;my listener&quot;, names, metrics_function, %{my_config: true}) :ok iex(4)&gt; {:ok, gnat} = Gnat.start_link() {:ok, #PID&lt;0.203.0&gt;} iex(5)&gt; Gnat.sub(gnat, self(), &quot;topic&quot;) [[:gnat, :sub], %{latency: 128000}, %{topic: &quot;topic&quot;}, %{my_config: true}] {:ok, 1} iex(6)&gt; Gnat.pub(gnat, &quot;topic&quot;, &quot;ohai&quot;) [[:gnat, :pub], %{latency: 117000}, %{topic: &quot;topic&quot;}, %{my_config: true}] [[:gnat, :message_received], %{count: 1}, %{topic: &quot;topic&quot;}, %{my_config: true}] :okThe pub , sub , request , and unsub events all report the latency of those respective calls. The message_received event reports a number of messages like %{count: 1} because there isn't a good latency metric to report. All of the events (except unsub ) include metadata with a :topic key so you can split your metrics by topic.","ref":"readme.html#instrumentation","title":"Gnat - Instrumentation","type":"extras"},{"doc":"Part of the motivation for building this library is to get better performance. To this end, there is a bench branch on this project which includes a server.exs and client.exs that can be used for benchmarking various scenarios.As of this commit, the latest benchmark on a 16-core server shows that you can make 170k+ req/sec or up to 192MB/sec.The bench/*.exs files also contain some straight-line single-CPU performance tests. As of this commit my 2018 MacBook pro shows.ipsaveragedeviationmedianparse-128487.67 K2.19 μs±1701.54%2 μspub - 12896.37 K10.38 μs±102.94%10 μsreq-reply-1288.32 K120.16 μs±23.68%114 μs","ref":"readme.html#benchmarks","title":"Gnat - Benchmarks","type":"extras"},{"doc":"Before running the tests make sure you have a locally running copy of nats-server ( brew install nats-server ). We currently use version 2.1.2 in CI, but anything higher than 0.9.6 should be fine. The typical mix test will run all the basic unit tests.You can also run the multi_server set of tests that test connectivity to different nats-server configurations. You can run these with mix test --only multi_server . The tests will tell you how to start the different configurations.There are also some property-based tests that generate a lot of test cases. You can tune how many test cases by setting the environment variable N=200 mix test --only property (default it 100).For more details you can look at how Travis runs these things in the CI flow.","ref":"readme.html#development","title":"Gnat - Development","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Gnat.Server behaviour with support in the ConsumerSupervisor https://github.com/nats-io/nats.ex/compare/1b1adc85e4b28231218ef87c7fc3445fce854377...b24a7e14325b51fbb93fde7e3d891d18b4fa8afbavoid logging sensitive credentials https://github.com/nats-io/nats.ex/pull/105deprecate Gnat.ping, improved typespecs https://github.com/nats-io/nats.ex/pull/103","ref":"changelog.html#1-2","title":"Changelog - 1.2","type":"extras"},{"doc":"add support for nkeys and NGS https://github.com/nats-io/nats.ex/pull/101Fix supervisor ConsumerSuperivsor crash https://github.com/nats-io/nats.ex/pull/96","ref":"changelog.html#1-1","title":"Changelog - 1.1","type":"extras"},{"doc":"Make supervisors officially supported https://github.com/nats-io/nats.ex/pull/96","ref":"changelog.html#1-0","title":"Changelog - 1.0","type":"extras"},{"doc":"update to telemetry 0.4 https://github.com/nats-io/nats.ex/pull/86 and https://github.com/nats-io/nats.ex/pull/87support for token authentication https://github.com/nats-io/nats.ex/pull/92support elixir 1.9 https://github.com/nats-io/nats.ex/pull/93","ref":"changelog.html#0-7-0","title":"Changelog - 0.7.0","type":"extras"},{"doc":"Dropped support for Erlang &lt; 19 and Elixir &lt;= 1.5Added Telemetry to the project (thanks @rubysolo)Switched to nimble_parsec for parsingUpdated benchmarking/performance information. We can now do 170k requests per second on a 16-core server.Fixed a bug around re-subscribing for the ConsumerSupervisorPass sid when delivering message (thanks @entone)Documentation fixes from @deini and @johannestroeger","ref":"changelog.html#0-6-0","title":"Changelog - 0.6.0","type":"extras"},{"doc":"Dropped support for Elixir 1.4 and OTP 18 releases. You will need to use Elixir 1.5+ and OTP 19+.Switched to running our tests against gnatsd 1.3.0","ref":"changelog.html#0-5-0","title":"Changelog - 0.5.0","type":"extras"}]